$(".lem").click(function(e){
    e.stopPropagation();
    var id = $(this).attr("id");
    var rdg = $(".rdg-digital[target-lem*=" + id + "]");
    var highlight = $(this).toggleClass("highlight-lem");

    var lem_height = $(this).height();
    var lem_width = $(this).width();
    var rdg_height = rdg.height();

    $(this).scaleSVG();
    rdg.prepareRdgs();

    var offset_top = $(this).offset().top;
    var std_margin_top = Math.floor(offset_top - 160);
    var overlap_area = rdg.getOverlapArea();
    var final_margin_top = overlap_area + 25;
    var has_rdg_been_moved = rdg.hasBeenMoved(std_margin_top, overlap_area);

    rdg.placeRdg(std_margin_top, overlap_area, final_margin_top, has_rdg_been_moved);
    //$(this).drawPath($(this), id, rdg, rdg_height, std_margin_top, overlap_area, final_margin_top, has_rdg_been_moved);
});


$(".rdg-digital, .rdg-insertion").click(function(e){
    var id = $(this).attr("id");
    var path = $("path[target-rdg*= " + id + "]");
    var lem_id = $(this).attr("target-lem");
    lem_id = lem_id.replace("#", "");
    var lem = $("span[id*= " + lem_id + "]");

    $(this).toggleClass("show");
    lem.toggleClass("highlight-lem");
    if($(this).hasClass("show")) {
        path.addClass("visible");
    } else
    {
        path.removeClass("visible");
    }

    /* display the rdg that has been opened before without opacity by removing
    backdrop class */
    var prev_no = $(this).attr("no") - 1;
    if(prev_no >= 0) {
        var prev_rdg = $(".backdrop[no=" + prev_no +"]");
        prev_rdg.removeClass("backdrop");
    }
});


$(".rdg-digital, .rdg-insertion").mouseenter(function(e){
    var id = $(this).attr("id");
    var path = $("path[target-rdg*= " + id + "]");
    var lem_id = $(this).attr("target-lem");
    lem_id = lem_id.replace("#", "");
    var lem = $("span[id*= " + lem_id + "]");

    lem.addClass("highlight-lem-hover");

    var offset_top = lem.offset().top;
    var std_margin_top = Math.floor(offset_top - 160);
    var overlap_area = $(this).getOverlapArea();
    var final_margin_top = overlap_area + 25;
    var has_rdg_been_moved = $(this).hasBeenMoved(std_margin_top, overlap_area);
    //$(this).drawPath(lem, lem_id, $(this), 0, std_margin_top, overlap_area, final_margin_top, has_rdg_been_moved);

    if(path.not($(this).hasClass("visible"))) {
        path.addClass("visible");
    }
});


$(".rdg-digital, .rdg-insertion").mouseleave(function(e){
    var id = $(this).attr("id");
    var path = $("path[target-rdg*= " + id + "]");
    var lem_id = $(this).attr("target-lem");
    lem_id = lem_id.replace("#", "");
    var lem = $("span[id*= " + lem_id + "]");

    lem.removeClass("highlight-lem-hover");
    path.removeClass("visible");
});


$(".variants-btn").click(function(e){
    var id = $(this).attr("id");
    var wit = id.substring(13, 14);

    var spans = $(".rdg-digital[wits*=" + wit + "]");

    spans.each(function (index, value) {
        var lem_id = $(this).attr('target-lem');
        lem_id = lem_id.replace('#', '');
        var lem = $(".lem[id*=" + lem_id + "]");
        lem.toggleClass('highlight-lem');

        var height = $(this).height();
        var offset_top = $(this).offset().top;
        var std_margin_top = Math.floor(offset_top - 160);
        var overlap_area = $(this).getOverlapArea();
        var final_margin_top = overlap_area + 25;
        var has_rdg_been_moved = $(this).hasBeenMoved(std_margin_top, overlap_area);

        $(this).placeRdg(std_margin_top, overlap_area, final_margin_top, has_rdg_been_moved);
        //$(this).drawPath(lem, lem_id, $(this), height, std_margin_top, overlap_area, final_margin_top, has_rdg_been_moved);
    });

});

$(".lem").hover(function(e){
    $(this).toggleClass("highlight-lem-hover");

    var id = $(this).attr("id");
    var rdg = $(".rdg-digital[target-lem*=" + id + "]");
    rdg.toggleClass("highlight-show");
});



/*===== custom functions =====*/

(function( $ ){
   $.fn.scaleSVG = function() {
        var svg = $(".svg-layer");
        var doc_width = $(document).width();
        var doc_height = $(document).height();

        if(!svg.attr("height")) {
            svg.attr("height", doc_height);
            svg.attr("width", doc_width);
        }
        return this;
   };
})( jQuery );


(function( $ ){
   $.fn.prepareRdgs = function() {
        /* in order to exclude the current rdg we select both the previous and the
        next ones. a solution with :not/.not([target-lem*=" + id + "]) had the effect
        that the current rdg has also been selected */
        var prev_rdgs = $(this).prevAll(".show");
        prev_rdgs.addClass("backdrop");
        var next_rdgs = $(this).nextAll(".show");
        next_rdgs.addClass("backdrop");

        var no_of_opened_rdgs = prev_rdgs.length + next_rdgs.length + 1;
        if(!$(this).attr("no")) {
            $(this).attr("no", no_of_opened_rdgs);
            $(this).css("z-index", no_of_opened_rdgs);
        } else {
            $(this).removeAttr("no");
            $(this).css("z-index", "");
        }
        return this;
   };
})( jQuery );


/* the general rules for the positioning of a rdg are:
    1. if possible, display it right beneath its lem
    2. there should be no overlapping. if overlapping is not avoidable, rdgs
        that have been opened latest should be displayed below the already opened ones
the offset from top is computed from the top of the page, but since the
variants are displayed in div[@id = variants], we have to subtract the
margin-top of the div to get the right margin-top of the variant.
furthermore we have to pay attention to the already opened rdgs and consider
their height plus their top/bottom margins */
(function( $ ){
   $.fn.placeRdg = function(std_margin_top, overlap_area, final_margin_top, has_rdg_been_moved) {
        if($(this).length > 1) {
            $(this).each(function( index ) {
                var new_overlap_area = overlap_area - $(this).height();
                if(index !== 0) {
                    $(this).setMarginTopWithPadding(std_margin_top, new_overlap_area, final_margin_top);
                } else {
                    $(this).setMarginTop(std_margin_top, new_overlap_area, final_margin_top);
                }
            });
        } else {
            $(this).setMarginTop(std_margin_top, overlap_area, final_margin_top);
        }
        $(this).toggleClass("show");
        return this;
    };
})( jQuery );


(function( $ ){
   $.fn.setMarginTop = function(std_margin_top, overlap_area, final_margin_top) {
        if(overlap_area >= std_margin_top) {
            $(this).css("margin-top", final_margin_top);
        } else {
            $(this).css("margin-top", std_margin_top);
        }

        return this;
   };
})( jQuery );


(function( $ ){
   $.fn.setMarginTopWithPadding = function(std_margin_top, overlap_area, final_margin_top) {
    var prev = $(this).prev();
    var prev_height = prev.height();

        if(overlap_area >= std_margin_top) {
            var margin_top = final_margin_top + prev_height + 25;
            $(this).css("margin-top", margin_top)
        } else {
            var margin_top = std_margin_top + prev_height + 25;
            $(this).css("margin-top", margin_top)
        }

        return this;
   };
})( jQuery );


(function( $ ){
   $.fn.getOverlapArea = function() {
        var margin_top_max = $(this).findMarginTopMax();
        overlap_area = margin_top_max + $(this).height() + 5;

        return overlap_area;
   };
})( jQuery );


(function( $ ){
   $.fn.findMarginTopMax = function(margin_top_max) {
        var margin_top_max = 0;
        $(".show").each(function()
            {
                var current_margin_top = $(this).css("margin-top");
                current_margin_top = current_margin_top.substr(0, current_margin_top.indexOf('p'));
                current_margin_top = parseInt(current_margin_top, 10);

                if(current_margin_top > margin_top_max) {
                    margin_top_max = current_margin_top;
                }
        });
        return margin_top_max;
   };
})( jQuery );


(function( $ ){
   $.fn.hasBeenMoved = function(std_margin_top, overlap_area) {
        var boolean = false;
        if(overlap_area >= std_margin_top) {
            boolean = true;
        }
        return boolean;
   };
})( jQuery );


(function( $ ){
   $.fn.drawPath = function(lem, id, rdg, rdg_height, std_margin_top, overlap_area, final_margin_top, has_rdg_been_moved) {
        if(rdg.length > 1) {
            rdg.each(function( index ) {
                var rdg_id = $(this).attr("id");
                var path = $("path[target-lem*=" + id +"][target-rdg*=" + rdg_id +"]");
                /* determining start and end coordinates of the path */
                /* + 2 considers border etc. */
                var path_start_y = lem.offset().top + lem.height() + 2;
                var path_start_x = lem.offset().left + lem.width() / 2;
                var path_end_y = $(this).getPathEndY(has_rdg_been_moved, final_margin_top, rdg_height, index);

                console.log(path_start_y);
                console.log(path_start_x);
                console.log(path_end_y);
            });
        } else {
            var path = $("path[target-lem*=" + id +"]");

            /* determining start and end coordinates of the path */
            /* + 2 considers border etc. */
            var path_start_y = lem.offset().top + lem.height() + 2;
            var path_start_x = lem.offset().left + lem.width() / 2;
            var path_end_y = rdg.getPathEndY(has_rdg_been_moved, final_margin_top, rdg_height);

            /* draw the path */
            var move_to = "M " + path_start_x + " " + path_start_y;

            var control_point_y = path_start_y + 3;
            var end_point_x = path_start_x + 3;
            var curving_at_lem = " Q " + path_start_x + " " +  control_point_y + ", " + end_point_x + " " + control_point_y;

            /* because div[@id = "digital-text"] has a padding-right of 15px, we have to
            compensate this and add an extra 30px to really hit the edge */
            var left_div_width = $("#digital-text").width() + 30
            var line_to_left_div_edge = " H" + left_div_width;

            /* from this point on we are in the area of div[@id = "variants"] and
            have 15px padding to for making the connection between the line and the
            rdg panel */
            var horizontal_line_to_curving_1 = " h 6";

            /* determine whether or not we need curvings at a rdg and how far to go down.
            curvings are only necessary if a rdg has been moved, because otherwise the
            rdg and the lem are on the same level. at the same time we have to keep in
            mind that the curvings also have a a horizontal extension of 6px which have
            to be considered for the horizontal connection between the path and the rdg */
            var curving_1_at_rdg = "";
            var curving_2_at_rdg = "";
            var horizontal_line_to_rdg = " h 9";
            var path_end_x = 0;
            var vertical_line = "v " + path_end_x;

            if(has_rdg_been_moved) {
                /* curvings */
                curving_1_at_rdg = " q 3 0, 3 3";
                curving_2_at_rdg = " q 0 3, 3 3";
                horizontal_line_to_rdg = " h 3";

                /* how far to go down */
                /* computation goes as follows:
                    + the area of overlapping
                    + 160px that has been subtracted for the std_margin_top and which are a result of the navbars, padding, etc.
                    + lem_height / 2 + 3 to get the current position of the path
                    + 25px for the padding between two rdgs
                    + rdg_height / 2 to get the middle of the current rdg
                */
                path_end_x = overlap_area + 160 + lem.height() / 2 + 3 + 25 + rdg_height / 2;
                vertical_line = "V " + path_end_x;
            }

            var final_d = move_to + curving_at_lem + line_to_left_div_edge +
                horizontal_line_to_curving_1 + curving_1_at_rdg + vertical_line +
                curving_2_at_rdg + horizontal_line_to_rdg;

            path.attr("d", final_d);

            path.toggleClass("visible");
        }

        return this;
   };
})( jQuery );


(function( $ ){
   $.fn.getPathEndY = function(has_rdg_been_moved, final_margin_top, rdg_height) {
        var end_y;
        if(has_rdg_been_moved) {
            end_y = final_margin_top + rdg_height / 2;
        } else {
            end_y = $(this).offset().top + rdg_height / 2;
        }
        return end_y;
   };
})( jQuery );

(function( $ ){
   $.fn.getPathEndY = function(has_rdg_been_moved, final_margin_top, rdg_height, index) {
        var end_y;

        // console.log(rdg_height);

        if(index == 0) {
            end_y = $(this).getPathEndY(has_rdg_been_moved, final_margin_top, rdg_height);
        } else {

        }
        return end_y;
   };
})( jQuery );



/****** QUOTES ******/
$(".quote-icon").click(function(e){
    e.stopPropagation();
    var id = $(this).parent().attr("id");
    var highlight = $(this).parent().toggleClass("highlight-quote");
    var quoted_text = $(".quoted-text[target-node*=" + id + "]");

    var quote_height = $(this).parent().height();
    var quote_width = $(this).parent().width();
    var quoted_text_height = quoted_text.height();

    $(this).scaleSVG();
    quoted_text.prepareRdgs();

    var offset_top = $(this).parent().offset().top;
    var std_margin_top = Math.floor(offset_top - 160);
    var overlap_area = quoted_text.getOverlapArea();
    var final_margin_top = overlap_area + 25;
    var has_quoted_text_been_moved = quoted_text.hasBeenMoved(std_margin_top, overlap_area);

    quoted_text.placeRdg(std_margin_top, overlap_area, final_margin_top, has_quoted_text_been_moved);
    $(this).parent().drawQuotePath($(this).parent(), id, quoted_text, quoted_text_height, std_margin_top, overlap_area, final_margin_top, has_quoted_text_been_moved);
});


$(".quoted-text").click(function(e){
    /*
     * visual effects in general: switch highlights off again and don't display
     * quoted text.
     */
    var id = $(this).attr("id");
    var quoting_id = $(this).attr("target-node");
    quoting_id = quoting_id.replace("#", "")
    var path = $("path[target-quoting*= " + quoting_id + "]");
    var quoting = $("span[id*= " + quoting_id + "]");

    $(this).toggleClass("show");
    path.toggleClass("visible");
    quoting.toggleClass("highlight-quote");


    /* display the rdg that has been opened before without opacity by removing
    backdrop class */
    var prev_no = $(this).attr("no") - 1;
    if(prev_no >= 0) {
        var prev_rdg = $(".backdrop[no=" + prev_no +"]");
        prev_rdg.removeClass("backdrop");
    }
});


$(".quoted-text").hover(function(e){
    var id = $(this).attr("id");
    var quoting_id = $(this).attr("target-node");
    quoting_id = quoting_id.replace("#", "")
    var quoting = $("span[id*= " + quoting_id + "]");

    quoting.toggleClass("highlight-quote-hover");
});


(function( $ ){
   $.fn.drawQuotePath = function(quoting, id, quoted_text, quoted_text_height, std_margin_top, overlap_area, final_margin_top, has_quoted_text_been_moved) {
        var path = $("path[target-quoting*=" + id +"]");

        /* determining start and end coordinates of the path */
        /* no + 2 to consider border etc. since we don't have these in Bahrdt/Semler */
        var path_start_y = quoting.offset().top + quoting.height();
        var path_start_x = quoting.offset().left + quoting.width() / 2;
        var path_end_y = quoted_text.getPathEndY(has_quoted_text_been_moved, final_margin_top, quoted_text_height);

        /* draw the path */
        var move_to = "M " + path_start_x + " " + path_start_y;

        var control_point_y = path_start_y + 3;
        var end_point_x = path_start_x + 3;
        var curving_at_quoting = " Q " + path_start_x + " " +  control_point_y + ", " + end_point_x + " " + control_point_y;

        /* because div[@id = "digital-text"] has a padding-right of 15px, we have to
        compensate this and add an extra 30px to really hit the edge */
        var left_div_width = $("#digital-text").width() + 30
        var line_to_left_div_edge = " H" + left_div_width;

        /* from this point on we are in the area of div[@id = "variants"] and
        have 15px padding to for making the connection between the line and the
        rdg panel */
        var horizontal_line_to_curving_1 = " h 6";

        /* determine whether or not we need curvings at a rdg and how far to go down.
        curvings are only necessary if a rdg has been moved, because otherwise the
        rdg and the lem are on the same level. at the same time we have to keep in
        mind that the curvings also have a a horizontal extension of 6px which have
        to be considered for the horizontal connection between the path and the rdg */
        var curving_1_at_quoted_text = "";
        var curving_2_at_quoted_text = "";
        var horizontal_line_to_quoted_text = " h 9";
        var path_end_x = 0;
        var vertical_line = "v " + path_end_x;

        if(has_quoted_text_been_moved) {
            /* curvings */
            curving_1_at_quoted_text = " q 3 0, 3 3";
            curving_2_at_quoted_text = " q 0 3, 3 3";
            horizontal_line_to_quoted_text = " h 3";

            /* how far to go down */
            /* computation goes as follows:
                + the area of overlapping
                + 160px that has been subtracted for the std_margin_top and which are a result of the navbars, padding, etc.
                + quoting_height / 2 + 3 to get the current position of the path
                + 25px for the padding between two rdgs
                + quoted_text_height / 2 to get the middle of the current quoted_text
            */
            path_end_x = overlap_area + 160 + quoting.height() / 2 + 3 + 25 + quoted_text_height / 2;
            vertical_line = "V " + path_end_x;
        }

        var final_d = move_to + curving_at_quoting + line_to_left_div_edge +
            horizontal_line_to_curving_1 + curving_1_at_quoted_text + vertical_line +
            curving_2_at_quoted_text + horizontal_line_to_quoted_text;

        path.attr("d", final_d);

        path.toggleClass("visible");

        return this;
   };
})( jQuery );
