/* Fixing a bug in Bootstrap where the Navbar hides content.
 * See https://github.com/twbs/bootstrap/issues/1768
 */
var shiftWindow = function() { scrollBy(0, -50) };
if (location.hash) shiftWindow();
window.addEventListener("hashchange", shiftWindow);


/**
 * Sitemap
 */

$("ul.sitemap ul").hide();

$("ul.sitemap i").click(function() {
    if ($(this).hasClass("fa-caret-right")) {
        $(this).removeClass("fa-caret-right").addClass("fa-caret-down");
        $(this).closest("ul").find("ul").show();
    } else if ($(this).hasClass("fa-caret-down")) {
        $(this).removeClass("fa-caret-down").addClass("fa-caret-right");
        $(this).closest("ul").find("ul").hide();
    }
});

$("a > i, div > i").click(function() {
    if ($(this).hasClass("fa-caret-down")) {
        $(this).removeClass("fa-caret-down").addClass("fa-caret-up");
    }
    else if($(this).hasClass("fa-caret-up")) {
        $(this).removeClass("fa-caret-up").addClass("fa-caret-down");
    }
});



/**
 * Interaction with elements (on click)
 */

$("a.textLink, .modelledition, [type='notAvailable'], .modal, .fa-book-link").click(function(e) {
  e.stopPropagation();
//  return true;
});


/**
 * RDF objects
 */

$(".fa-user-link").click(function(e) {
    e.stopPropagation();
    var uri = document.getElementById(this.id).getAttribute("tgURI");

//    $.get('http://localhost:8080/exist/apps/sade/templates/rest/persons.xql?id=' + uri, function(data) {
    $.get('https://dev.bdn-edition.de/templates/rest/persons.xql?id=' + uri, function(data) {
        var template = $('#modalUserTpl').html(); /* in page.html */
        var html = Mustache.to_html(template, data);
        $('.modalArea').html(html); /* in book.html */

        $(html).modal('show');
    });
});

$(".fa-user-link").mouseover(function(e) {
    var id = document.getElementById(this.id).getAttribute("id");
    var uri = document.getElementById(this.id).getAttribute("tgURI");

//     $.get('http://localhost:8080/exist/apps/sade/templates/rest/persons.xql?id=' + uri, function(data) {
    $.get('https://dev.bdn-edition.de/templates/rest/persons.xql?id=' + uri, function(data) {
        var template = "{{person.dnb.name}}{{person.cerl.name}}";
        var html = Mustache.render(template, data);
        /* during the query all ' are replaced with &#39; */
        html = html.replace(/&#39;/g, "'");

        $("#" + id).attr("title", html);
    });
});


$(".fa-book-link").click(function(e) {
    e.stopPropagation();
    e.preventDefault();

    var tempID = document.getElementById(this.id).getAttribute("id");
    var uri = document.getElementById(this.id).getAttribute("tgURI");

//   $.get('http://localhost:8080/exist/apps/sade/templates/rest/books.xql?id=' + uri, function(data) {
    $.get('https://dev.bdn-edition.de/templates/rest/books.xql?id=' + uri, function(data) {

        var template = $('#modalBookTpl').html();
        var html = Mustache.render(template, data);
        $('.modalArea').html(html);

        $(html).modal('show');
    });
});


$(".fa-book-link").mouseover(function(e) {
    e.stopPropagation();

    var id = document.getElementById(this.id).getAttribute("id");
    var uri = document.getElementById(this.id).getAttribute("tgURI");

//    $.get('http://localhost:8080/exist/apps/sade/templates/rest/books.xql?id=' + uri, function(data) {
    $.get('https://dev.bdn-edition.de/templates/rest/books.xql?id=' + uri, function(data) {
        var template = "{{book.opac}}";
        var html = Mustache.render(template, data);
        /* during the query all slashes are replaced with &#x2F; */
        html = html.replace(/&#x2F;/g, "/");

        $("#" + id).attr("href", html);
    });
});


$("#book .fa-comment").click(function(e) {
    e.stopPropagation();
    var target = this.getAttribute("data-target");

    $(target).modal('show');
});


$(".comp-error").click(function(e) {
    e.stopPropagation();

    var target_id = $(this).attr("data-target").replace("#", "");
    var target = $("div[id=" + target_id + "]");

    $(target).modal('show');
});


$(".editorial-commentary, .expan-content").click(function(e) {
    e.stopPropagation();

    var target_id = $(this).attr("href").replace("#", "");
    var target = $("div[id=" + target_id + "]");

    $(target).modal('show');
});


/* temporary solution for the sample edition. has to be adjusted for real edition! */
$(document).ready(function() {

    $("[type='notAvailable'] i").css({"color": "#595959", "cursor": "default"});

    var stickyTop = $('#register-nav').offset().top - 45; // returns number considering the header
    $(window).scroll(function(){
        var windowTop = $(window).scrollTop(); // returns number
        if (stickyTop < windowTop) {
            $('#register-nav').css({ position: 'fixed', top: '51px', width: '59.4%' });
        }
        else {
            $('#register-nav').css({position: 'static', width: '100%', });
        }
    });

    /*via http://www.jquerybyexample.net/2012/06/get-url-parameters-using-jquery.html
    http://stackoverflow.com/questions/19491336/get-url-parameter-jquery-or-how-to-get-query-string-values-in-js */

    var getUrlParameter = function getUrlParameter(sParam) {
        var sPageURL = decodeURIComponent(window.location.search.substring(1)),
            sURLVariables = sPageURL.split('&'),
            sParameterName,
            i;

        for (i = 0; i < sURLVariables.length; i++) {
            sParameterName = sURLVariables[i].split('=');

            if (sParameterName[0] === sParam) {
                return sParameterName[1] === undefined ? true : sParameterName[1];
            }
        }
    };


    /* highlighting words or substrings if document is called from result.html
    (after search operation) */

    var highlight = getUrlParameter('key');
    var expand = getUrlParameter('expand');
    var keyArray;

    if(highlight.toLowerCase().indexOf('*') > -1){
        $(".corner-button").css({"display": "inline"});

        if(highlight.toLowerCase().indexOf('+') > -1) {
            keyArray = highlight.split('+');
        }
        else
            keyArray = highlight.split('*');

        var iii;
        for(iii = 0; iii < keyArray.length; iii++) {
            if(keyArray[iii].indexOf('*') > -1) {
                var keyArrayTmp = keyArray[iii].split('*');

                var jjj;

                for(jjj = 0; jjj < keyArrayTmp.length; jjj++) {
                    $("div > div.p").highlight(keyArrayTmp[jjj]);
                }
            }
            $("div > div.p").highlight(keyArray[iii]);
        }
    }
    else if(highlight.toLowerCase().indexOf('+') !== 0) {
        $(".corner-button").css({"display": "inline"});

        keyArray = highlight.split('+');

        var iii;
        for(iii = 0; iii < keyArray.length; iii++) {
            $("div > div.p").highlight(keyArray[iii]);
        }
    }
    else if(hightlight) {
        $(".corner-button").css({"display": "inline"});
        $("div > div.p").highlight(highlight);
    }
});


/* activating loader icon if ajax is active */
$body = $("body");

$(document).bind({
    ajaxStart: function() { $body.addClass("loading");    },
    ajaxStop: function() { $body.removeClass("loading"); }
});


$('.help').mouseover(function(e)
 {
    $(this).tooltip('show');
 });


$('.result p').css('margin-bottom', '20px');
$('.result p').after('<hr/>');
/*var content = $('.result p').html();


$('.result p').replaceWith('<li class="list-group-item">' + content + '</li>');*/


$('.dropdown-submenu .submenu-link').on("click", function(e) {
    $(this).next('ul').toggle();
    e.stopPropagation();
    e.preventDefault();
});

function sendMail() {
    var subject = encodeURIComponent(document.getElementById('mailSubject').value)
    var body = encodeURIComponent(document.getElementById('mailContent').value + '\n')

    var link = "mailto:neologie@gwdg.de"
             + "?subject=" + subject
             + "&body=" + body
    ;

    window.location.href = link;
}


/* hide overlay for small screens */

function hideOverlay() {
    $('#small-screen-warning').addClass("small-screen-hide");
}


/* disable links to printings for which there is no text (because of structural
variance) */
$("a.disabled").click(function(e) {
    e.stopPropagation();
    e.preventDefault();
});

$(".navbar-work-btn").click(function(e) {
    e.stopPropagation();
    e.preventDefault();

    if ($(this).find("svg").hasClass("fa-caret-down")) {
        $(this).removeClass("fa-caret-down").addClass("fa-caret-up");
    } else if ($(this).find("svg").hasClass("fa-caret-up")) {
        $(this).removeClass("fa-caret-up").addClass("fa-caret-down");
    }

    $(this).next(".navbar-work-subitem-container").toggle();
});

$(".overview-entry").click(function(e) {
    e.stopPropagation();
    e.preventDefault();

    $(this).find(".svg-inline--fa").toggleClass("fa-caret-down").toggleClass("fa-caret-up");

    $(this).next(".overview-subentry-container").children().toggleClass("overview-show");

});
